open BinTree;;

let rec gcd a b = (* Euclidean GCD *)
  if b = 0 then a else gcd b (a mod b);;

let rec reduce' = function
  | Empty -> failwith "reduce' on Empty"
  | Node(Empty,v,Empty) -> (v,1)
  | Node(l,v,r) ->
    let (lnum,ldenom) = reduce' l in
    let (rnum,rdenom) = reduce' r in
    let denom = rnum * ldenom in
    (v * denom + lnum * rdenom, denom)

let reduce t =
  let (num,denom) = reduce' t in
  let the_gcd = gcd num denom in
  let num = num / the_gcd in
  let denom = denom / the_gcd in
  make [num mod denom; num / denom; denom]
