open BinTree;;

let rec leftmost = function
  | Empty -> failwith "leftmost on empty tree"
  | Node(l,v,_) -> if l = Empty then v else leftmost l

let rec remove_leftmost = function
  | Empty -> failwith "remove_leftmost on empty tree"
  | Node(l,v,r) -> if l = Empty then r else Node(remove_leftmost l, v, r)

let rec delete tree elem = match tree with
  | Empty -> Empty
  | Node(l,v,r) ->
    let cmp = compare elem v in
    if cmp < 0 then (* elem should be in the left half *)
      Node(delete l elem, v, r)
    else if cmp > 0 then (* elem should be in the right half *)
      Node(l, v, delete r elem)
    (* the other case is cmp = 0; have to delete this node *)
    else if r = Empty then l (* if r is Empty, just take l *)
    else if l = Empty then r (* if l is Empty, just take r *)
    else (* otherwise, move the leftmost node in r to the root *)
        Node(l, leftmost r, remove_leftmost r)

